﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SQLite;
using System.Linq;
using System.Text;

namespace DBShardTools.Core
{
    public class ConfigService : IConfigService
    {
        public const string ConnectionString = "Data Source=Config.db;Version=3";
        public bool AddConnection(string name, string databaseType, string host, int port, string database, string userName, string password)
        {
            string commandText = string.Format(@"insert into Connection(Name,Host,Port,UserName,Password,DatabaseType,Database)
                                                                 values('{0}','{1}','{2}','{3}','{4}','{5}','{6}')",name,host,port,userName,password,databaseType,database);
            IDbConnection conn;
            IDbCommand comm;
            using (conn = new SQLiteConnection(ConnectionString))
            {
                comm = conn.CreateCommand();
                conn.Open();
                comm.CommandText = commandText;
                try
                {
                    comm.ExecuteNonQuery();
                    return true;
                }
                catch (Exception ex)
                {
                    throw ex;
                }
            }
            return false;
            
        }

        public bool SaveConnection(string name, string databaseType, string host, int port, string database, string userName, string password)
        {
            if (!IsConnectionExists(name))
                return AddConnection(name, databaseType, host,  port,  database,  userName,  password);
            return SaveConnectionInternal( name,  databaseType,  host,  port,  database,  userName,  password);
        }
        private  bool SaveConnectionInternal(string name, string databaseType, string host, int port, string database, string userName, string password)
        {
            if (!IsConnectionExists(name))
                return AddConnection(name, databaseType, host, port, database, userName, password);

            string commandText = string.Format(@"update  Connection set Host='{1}',Port='{2}',UserName='{3}',Password='{4}',DatabaseType='{5}',Database='{6}' where Name='{0}'",
                                                 name, host, port, userName, password, databaseType, database);
            IDbConnection conn;
            IDbCommand comm;
            using (conn = new SQLiteConnection(ConnectionString))
            {
                comm = conn.CreateCommand();
                conn.Open();
                comm.CommandText = commandText;
                try
                {
                    comm.ExecuteNonQuery();
                    return true;
                }
                catch (Exception ex)
                {
                    throw ex;
                }
            }
            return false;
        }
        public bool IsConnectionExists(string name)
        {
            string commandText = string.Format(@"select count(*) from  Connection where Name='{0}'", name);
            IDbConnection conn;
            IDbCommand comm;
            object result;
            using (conn = new SQLiteConnection(ConnectionString))
            {
                comm = conn.CreateCommand();
                conn.Open();
                comm.CommandText = commandText;
                try
                {
                    result = comm.ExecuteScalar();
                    if (result != null && (Int64)result == 1)
                    return true;
                }
                catch (Exception ex)
                {
                    throw ex;
                }
            }
            return false;
        }

        public IConnection GetConnection(string name)
        {
            string commandText = string.Format(@"select * from  Connection where Name='{0}'", name);
            IDbConnection conn;
            IDbCommand comm;
            IDataReader dataReader;
            IConnection connection = null;
            using (conn = new SQLiteConnection(ConnectionString))
            {
                comm = conn.CreateCommand();
                conn.Open();
                comm.CommandText = commandText;
                try
                {
                    dataReader = comm.ExecuteReader();
                    if (dataReader.Read())
                    {

                        connection = new Connection();
                        connection.Id = Convert.ToInt32(dataReader["Id"]);
                        connection.Name = Convert.ToString(dataReader["Name"]);
                        connection.DatabaseType = Convert.ToString(dataReader["DatabaseType"]);
                        connection.Host = Convert.ToString(dataReader["Host"]);
                        connection.Port = Convert.ToInt32(dataReader["Port"]);
                        connection.Database = Convert.ToString(dataReader["Database"]);
                        connection.UserName = Convert.ToString(dataReader["UserName"]);
                        connection.Password = Convert.ToString(dataReader["Password"]);
                        return connection;
                    }
                    return null;
                }
                catch (Exception ex)
                {
                    throw ex;
                }
            }
            return connection;
        }

        public IConnection[] GetConnections()
        {
            string commandText = string.Format(@"select * from  Connection");
            IDbConnection conn;
            IDbCommand comm;
            IDataReader dataReader;
            List<IConnection> connections = new List<IConnection>();
            using (conn = new SQLiteConnection(ConnectionString))
            {
                comm = conn.CreateCommand();
                conn.Open();
                comm.CommandText = commandText;
                try
                {
                    dataReader = comm.ExecuteReader();
                    while (dataReader.Read())
                    {

                        IConnection connection = new Connection();
                        connection.Id = Convert.ToInt32(dataReader["Id"]);
                        connection.Name = Convert.ToString(dataReader["Name"]);
                        connection.DatabaseType = Convert.ToString(dataReader["DatabaseType"]);
                        connection.Host = Convert.ToString(dataReader["Host"]);
                        connection.Port = Convert.ToInt32(dataReader["Port"]);
                        connection.Database = Convert.ToString(dataReader["Database"]);
                        connection.UserName = Convert.ToString(dataReader["UserName"]);
                        connection.Password = Convert.ToString(dataReader["Password"]);
                        connections.Add(connection);
                    }
                    return connections.ToArray();
                }
                catch (Exception ex)
                {
                    throw ex;
                }
            }
            return null; ;
        }
    }
}
