﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace DBShardTools.Core
{
    public class Utils
    {
        public static  string ParseTableNameFromCreateTableDdl(string createTableDdl)
        {
            Regex regex = new Regex(@"CREATE\s+TABLE\s+[\[`](?<TableName>.*?)[\]`].*",RegexOptions.IgnoreCase | RegexOptions.Singleline);
            Match match = regex.Match(createTableDdl);
            if (match != null && match.Groups.Count > 0 && match.Groups["TableName"] != null)
                return match.Groups["TableName"].Value;

                return null;

        }
        public static string ReplaceTableNameOfCreateTableDdl(string createTableDdl,string newTableName )
        {
            Regex regex = new Regex(@"(CREATE\s+TABLE\s+[\[`])(.*?)([\]`].*)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            return regex.Replace(createTableDdl,"$1"+newTableName+"$3");
        }
        public static string ParseTableNameFromDropTableDdl(string dropTableDdl)
        {
            Regex regex = new Regex(@"DROP\s+TABLE\s+[\[`](?<TableName>.*?)[\]`].*", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            Match match = regex.Match(dropTableDdl);
            if (match != null && match.Groups.Count > 0 && match.Groups["TableName"] != null)
                return match.Groups["TableName"].Value;

            return null;

        }
        public static string ReplaceTableNameOfDropTableDdl(string dropTableDdl, string newTableName)
        {
            Regex regex = new Regex(@"(DROP\s+TABLE\s+[\[`])(.*?)([\]`].*)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            return regex.Replace(dropTableDdl, "$1" + newTableName + "$3");
        }
        public static string ParseTableNameFromAlterTableDdl(string alterTableDdl)
        {
            Regex regex = new Regex(@"ALTER\s+TABLE\s+[\[`](?<TableName>.*?)[\]`].*", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            Match match = regex.Match(alterTableDdl);
            if (match != null && match.Groups.Count > 0 && match.Groups["TableName"] != null)
                return match.Groups["TableName"].Value;

            return null;

        }
        public static string ReplaceTableNameOfAlterTableDdl(string alterTableDdl, string newTableName)
        {
            Regex regex = new Regex(@"(ALTER\s+TABLE\s+[\[`])(.*?)([\]`].*)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            return regex.Replace(alterTableDdl, "$1" + newTableName + "$3");
        }
    }
}
