﻿using System;
using System.Configuration;
using System.Windows.Forms;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;

namespace DBShardTools.UI
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            IUnityContainer container = new UnityContainer();
            ConfigureContainer(container);

            if (container.Resolve<ConfigForm>().ShowDialog() == DialogResult.OK)
                Application.Run(container.Resolve<ShardTableForm>());
        }
        private static void ConfigureContainer(IUnityContainer container)
        {
            const string configFile = "Unity.config";
            const string sectionName = "unity";
            ExeConfigurationFileMap fileMap = new ExeConfigurationFileMap { ExeConfigFilename = configFile };
            Configuration configuration =
                ConfigurationManager.OpenMappedExeConfiguration(fileMap, ConfigurationUserLevel.None);
            UnityConfigurationSection section = (UnityConfigurationSection)configuration.GetSection(sectionName);
            container.LoadConfiguration(section);
        }

    }
}
