﻿using DBShardTools.Core;
using NUnit.Framework;

namespace DBShardTools.UnitTest
{
    [TestFixture]
    public class ConnectionStringBuilderTest
    {
        [Test]
        public void TestMySqlConnectionStringBuilder()
        {
            IPersister persister = new MySqlPersister();
            persister.Host = "localhost";
            persister.UserName = "root";
            persister.Password = "root";
            persister.Database = "bklog";
            persister.Port = 3306;
            IConnectionStringBuilder connectionStringBuilder = new MySqlConnectionStringBuilder();
            Assert.AreEqual("Host=localhost;Port=3306;UserName=root;Password=root;Database=bklog", connectionStringBuilder.BuildConnectionString(persister));

        }
        [Test]
        public void TestSqlConnectionStringBuilder()
        {
            IPersister persister = new SqlPersister();
            persister.Host = "localhost";
            persister.UserName = "sa";
            persister.Password = "";
            persister.Database = "bklog";
            persister.Port = 1433;
            IConnectionStringBuilder connectionStringBuilder = new SqlConnectionStringBuilder();
            Assert.AreEqual("Data Source=localhost,1433;User Id=sa;Password=;Initial Catalog=bklog", connectionStringBuilder.BuildConnectionString(persister));

        }
    }
}
